import Vue from 'vue';
import Vuex from 'vuex';
import axios from 'axios';
import _ from 'lodash';

Vue.use(Vuex);
const api = {
  columnQuery: `/api/cms/column/list`,
  columnFetch: `/api/cms/column/fetch/{id}`,
};
export const state = () => ({});
export const mutations = {};
export const actions = {
  //请求所有的栏目
  async getAllColumn({ commit, dispatch }, payload) {
    let toGet = () => {
      let res = [];
      for (const id of payload) {
        res.push(
          dispatch('columnOperation', {
            type: 'list',
            data: { parent_id: id },
          })
        );
      }
      return res;
    };
    let result = await axios.all(toGet());
    //降维
    let arr = _.flattenDeep(_.flattenDeep(result).map(item => item.data));
    return arr;
  },
  //栏目管理
  async columnOperation({ state }, { type, data }) {
    let { skip, limit } = data;
    let result;
    if (type === 'list') {
      let { parent_id } = data;
      result = await this.$axios.$get(api.columnQuery, {}, { parent_id: parent_id, is_use: '0' });
    }
    if (type === 'search') {
      let { parent_id } = data;
      result = await this.$axios.$get(api.columnFetch, {
        id: parent_id,
      });
    }
    return result;
  },
};
