import Vue from 'vue';
import Vuex from 'vuex';
import _ from 'lodash';
import axios from 'axios';

Vue.use(Vuex);
const api = {
  bugList: `/api/cms/newscreeper/list`,
  newsQuery: `/api/cms/news/list`,
  bugInfo: `/api/cms/newscreeper/fetch/{id}`,
};
export const state = () => ({});
export const mutations = {};
export const actions = {
  async getAllNews({ commit, dispatch }, payload) {
    let toGet = () => {
      let res = [];
      for (const item of payload) {
        let data = {
          skip: 0,
          limit: 4,
        };
        if (item.type === 'bugList') {
          data.news_type = `0`;
          data.parent_id = item.content_id;
        } else {
          data.news_type = `1`;
          data.parent_id = item.id;
        }
        res.push(
          dispatch('newsOperation', {
            type: 'list',
            data,
          })
        );
      }
      return res;
    };
    let result = await axios.all(toGet());
    //降维
    let arr = _.flattenDeep(_.flattenDeep(result).map(item => item.data));
    return arr;
  },
  async getAllNewsInfo({ commit, dispatch }, payload) {
    let toGet = () => {
      let res = [];
      for (const item of payload) {
        res.push(
          dispatch('newsOperation', {
            type: 'search',
            data: { id: item },
          })
        );
      }
      return res;
    };
    let result = await axios.all(toGet());
    //降维
    let arr = _.flattenDeep(result.map(item => item.data));
    return arr;
  },
  // 信息管理
  async newsOperation({ state }, { type, data }) {
    let { skip, limit } = data;
    let result;
    if (type === 'list') {
      let { parent_id, news_type } = data;
      if (news_type === '0') {
        result = await this.$axios.$get(api.bugList, {}, { parent_id: parent_id, skip: skip, limit: limit, is_use: '0' });
      } else {
        result = await this.$axios.$get(api.newsQuery, {}, { parent_id: parent_id, skip: skip, limit: limit, is_use: '0' });
      }
    }
    if (type === 'search') {
      let { id, news_type } = data;
      result = await this.$axios.$get(api.bugInfo, { id: id });
    }
    return result;
  },
};
